# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for license information.
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is regenerated.
# --------------------------------------------------------------------------

from enum import Enum
from azure.core import CaseInsensitiveEnumMeta


class RegionCategory(str, Enum, metaclass=CaseInsensitiveEnumMeta):
    """The category of the region."""

    RECOMMENDED = "Recommended"
    OTHER = "Other"


class RegionType(str, Enum, metaclass=CaseInsensitiveEnumMeta):
    """The type of the region."""

    PHYSICAL = "Physical"
    LOGICAL = "Logical"


class ResourceNameStatus(str, Enum, metaclass=CaseInsensitiveEnumMeta):
    """Is the resource name Allowed or Reserved."""

    ALLOWED = "Allowed"
    RESERVED = "Reserved"


class SpendingLimit(str, Enum, metaclass=CaseInsensitiveEnumMeta):
    """The subscription spending limit."""

    ON = "On"
    OFF = "Off"
    CURRENT_PERIOD_OFF = "CurrentPeriodOff"


class SubscriptionState(str, Enum, metaclass=CaseInsensitiveEnumMeta):
    """The subscription state. Possible values are Enabled, Warned, PastDue, Disabled, and Deleted."""

    ENABLED = "Enabled"
    WARNED = "Warned"
    PAST_DUE = "PastDue"
    DISABLED = "Disabled"
    DELETED = "Deleted"


class TenantCategory(str, Enum, metaclass=CaseInsensitiveEnumMeta):
    """Category of the tenant."""

    HOME = "Home"
    PROJECTED_BY = "ProjectedBy"
    MANAGED_BY = "ManagedBy"
